Package org.zkoss.bind.sys.debugger

## Class DebuggerFactory

- java.lang.Object
- - org.zkoss.bind.sys.debugger.DebuggerFactory

- Direct Known Subclasses:
    `DefaultDebuggerFactory`

      public abstract class DebuggerFactory
      extends java.lang.Object

  The factory to provide `DebuggerFactory` instance. It is also possible to provide null instance depends on the configuration(a production env should always provide nothing)
  Since:
    6.5.2
  Author:
    dennis

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `ENABLE_PROP` |
    `static java.lang.String` | `FACTORY_CLASS_PROP` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DebuggerFactory()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract BindingAnnotationInfoChecker` | `getAnnotationInfoChecker()` | Get the checker, the sub-class have to consider the thread-safe issue when implementing.
    `abstract BindingExecutionInfoCollector` | `getExecutionInfoCollector()` | Get the collector, the sub-class have to consider the thread-safe issue when implementing.
    `static DebuggerFactory` | `getInstance()` | Thread safe method to get the factory instance

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ENABLE_PROP

          public static final java.lang.String ENABLE_PROP

      See Also:
        Constant Field Values

    - #### FACTORY_CLASS_PROP

          public static final java.lang.String FACTORY_CLASS_PROP

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DebuggerFactory

          public DebuggerFactory()

  - ### Method Detail

    - #### getExecutionInfoCollector

          public abstract BindingExecutionInfoCollector getExecutionInfoCollector()

      Get the collector, the sub-class have to consider the thread-safe issue when implementing.
      Returns:
        the BindingExecutionInfoCollector or null if isn't existed

    - #### getAnnotationInfoChecker

          public abstract BindingAnnotationInfoChecker getAnnotationInfoChecker()

      Get the checker, the sub-class have to consider the thread-safe issue when implementing.
      Returns:
        the BindingAnnotationInfoChecker or null if isn't existed

    - #### getInstance

          public static DebuggerFactory getInstance()

      Thread safe method to get the factory instance
      Returns:
        default factory, null if there is no factory existed